VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "vbz CD-MediaType"
   ClientHeight    =   3195
   ClientLeft      =   5550
   ClientTop       =   4125
   ClientWidth     =   4530
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4530
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2400
      Left            =   120
      TabIndex        =   2
      Top             =   180
      Width           =   4275
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "&Beenden"
      Height          =   375
      Left            =   3060
      TabIndex        =   0
      Top             =   2700
      Width           =   1335
   End
   Begin VB.Label vbzentrum 
      Caption         =   "www.vb-zentrum.de"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   225
      Left            =   120
      TabIndex        =   1
      ToolTipText     =   "zur Homepage..."
      Top             =   2880
      Width           =   1770
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' vbzTipp   : Multimedia / CDMediaType
' Nummer    : 0004
' Stand     : 12.01.2005
' Quelle    : http://www.vb-zentrum.de - ralf schlegel

Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

' Deklarationen zum ermitteln von CD und Medientyp:
Private Declare Function GetDriveType Lib "kernel32.dll" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long            ' Laufwerkstyp ermitteln
Private Declare Function GetVolumeInformation Lib "kernel32.dll" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Enum CDMType    ' CD Medientyp
   cdNone = -1
   cdNoMedia = 0
   cdAudio = 1
   cdData = 2
End Enum
' Konstanten fr GetDriveType
Private Const DRV_REMOVABLE = &H2
Private Const DRV_FIXED = &H3
Private Const DRV_REMOTE = &H4
Private Const DRV_CDROM = &H5
Private Const DRV_RAMDISK = &H6

' Prfen, ob ein Laufwerk ein CD-Laufwerk ist und
' gegebenenfalls das eingelegte Medium ermitteln:
Private Function isCDMedia(ByVal drive As String) As CDMType
  Dim drv As String
  Dim VolumeName As String * 256
  Dim FileSystemName As String * 256
  Dim drvType As Long, Seriennr As Long
  Dim MaxLen As Long, SysFlags As Long

  isCDMedia = cdNone
  drv = Left$(drive, 1) & ":\"
  
  ' 1. grundstzlich auf CD- oder Netzlaufwerk prfen:
  drvType = GetDriveType(drv)
  If drvType <> DRV_CDROM And drvType <> DRV_REMOTE Then Exit Function
  
  ' 2. wenn mglich, Medientyp ermitteln
  If (GetVolumeInformation(drv, VolumeName, 255, Seriennr, MaxLen, SysFlags, FileSystemName, 255) = 0) Then
    isCDMedia = cdNoMedia
  Else
    If (Left$(VolumeName, 8) = "Audio CD") Then
      isCDMedia = cdAudio
    Else
      If (Left$(FileSystemName, 4) = "CDFS") Then isCDMedia = cdData
    End If
  End If
End Function

Private Sub cmdEnd_Click()
  Unload Me
End Sub

Private Sub Form_Load()
  Dim i As Long
  Dim s As String

  For i = 65 To 90  ' Laufwerk A...Z
    Select Case isCDMedia(Chr(i) + ":\")
      Case cdNoMedia
        s = "kein Medium eingelegt"
      Case cdAudio
        s = "Audio-CD vorhanden"
      Case cdData
        s = "Daten-CD vorhanden"
      Case Else
        s = ""
    End Select
    If s <> "" Then List1.AddItem (Chr(i) & ": " & s)
  Next
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Set frmMain = Nothing
End Sub

Private Sub vbzentrum_Click()
  Me.MousePointer = vbHourglass
  ShellExecute Me.hwnd, "Open", "http://www.vb-zentrum.de", "", "", vbNormalFocus
  Me.MousePointer = vbDefault
End Sub
